track.extrema <-
function(r,startpoint,ngbr,type,method,endcon){
if (type=="min") {ext=which.min}
if (type=="max") {ext=which.max}
#dummies
track<-vector()
adj.all<-vector()
adj<-vector()
values<-vector()
max.cell<-NA
#define moving window
window<-matrix(1,ncol=ngbr,nrow=ngbr)
mid.coor<-(ngbr^2+1)/2
window[mid.coor]<-0
#get CELL from coordinates
startcell<-cellFromXY(r,startpoint)
#as long no NA in moving window the extrema is computed
i=1
while (!(any(is.na(values))))
{
track[i]<-startcell #add startcell to track
adj<-adjacent(r,startcell,window) #calculate neigbors
if (length(which(adj[,2] %in% adj.all))!=0)
{
adj<-adj[-which(adj[,2] %in% adj.all),] #remove used cells
}
if (length(adj)==0) break #break if no cells are left
#searches the extrema cell in moving window and renames it to startcell 
  if (length(adj)>2)
  {  
  values<-(extract(r,adj[,2]))
  ext.cell<-ext(extract(r,adj[,2]))
  last.start.cell<-startcell
  startcell<-as.numeric(adj[ext.cell,2])
  ext.value<-extract(r,startcell)
  last.ext.value<-extract(r,last.start.cell)
    if (method=="single")
      {  
      adj.all<-c(adj.all,startcell,last.start.cell)
      }
      if (method=="multi")
      {  
      adj.all<-c(adj.all,adj[,2],startcell,last.start.cell)
      }
    }else{
    values<-(extract(r,adj[2]))
    ext.cell<-ext(extract(r,adj[2]))
    last.start.cell<-startcell
    startcell<-as.numeric(adj[ext.cell])
    ext.value<-extract(r,startcell)
    last.ext.value<-extract(r,last.start.cell)
      if (method=="single")
      {  
      adj.all<-c(adj.all,startcell,last.start.cell)
      }
      if (method=="multi")
      {  
      adj.all<-c(adj.all,adj[2],startcell,last.start.cell)
      } 
    }
i=i+1
#breaks if endcon is true
if (is.numeric(endcon))
{
if (type=="min") {if(ext.value<endcon) break}
if (type=="max") {if(ext.value>endcon) break}
}
if (!is.numeric(endcon))
{
  if (type=="min") {if(ext.value>last.ext.value) break} 
  if (type=="max") {if(ext.value<last.ext.value) break}
}
}
track.xy<-xyFromCell(r,track) #coordinates from cells
return(track.xy)
}
