\name{lineaDEM-package}
\alias{lineaDEM-package}
\alias{lineaDEM}
\docType{package}
\title{
\packageTitle{lineaDEM}
}
\description{
\packageDescription{lineaDEM}
}
\details{
R package for morphometric analysis of objects of type RasterLayer. Major functions are a multi direction, multi scale roughness filter [toporough()] and a iterative hough transformation [hough.rough] to detect lineaments with a modified output of toporogh().
}
\author{
\packageAuthor{lineaDEM}

Maintainer: \packageMaintainer{lineaDEM}
}
\references{

}
\keyword{ raster }
\seealso{
\code{\link[raster:raster-package]{raster}}
}
\examples{
data("work.data",package="lineaDEM") #import data
dem.mara<-work.data[[3]]
rough<-toporough(dem.mara,"max",11,"qu",0.5)
plot(rough[[1]]) #plot roughness map
}
