hypso <-
function(r.dem,min.ele)
{
if (is.na(min.ele))
{  
elev<-r.dem[]
elev<-na.omit(elev)
}else{
elev<-ifelse(r.dem[]>=min.ele,r.dem[],NA)
elev<-na.omit(elev) 
}
data<-matrix(NA,nrow=length(elev),ncol=3)
colnames(data)<-c("cumulative relative area","elevation [m]","relative elevation")
data[,2]<-sort(elev,decreasing = T)
data[,1]<-cumsum(as.numeric(c(1:length(elev))))/max(cumsum(as.numeric(c(1:length(elev)))))
data[,3]<-(data[,2]-min(data[,2]))/(max(data[,2])-min(data[,2]))

hi<-sum(data[,3])/length(data[,3])
return(list(data,hi))
}
