\name{work.data}
\alias{work.data}
\docType{data}
\title{
Datasets used in examples.
}
\description{
Data of class RasterLayer used in examples.
}
\usage{data("work.data")}
\format{
List of 3 Formal class 'RasterLayer' [package "raster"].}
\details{
List of 3 Formal class 'RasterLayer' [package "raster"].

1st: Digital elevation model of Austria. RasterLayer from the command getData('alt',country="AUT") of the raster package, bilinear interpolated to "+proj=tmerc +lat_0=0 +lon_0=13.33333333333333 +k=1 +x_0=450000 +y_0=-5000000 +ellps=bessel +towgs84=577.326,90.129,463.919,5.13" and a resolution of 1000 meter.

2nd: Drainage accumulation map of Austria. Derived from the provided digital elevation model of austria with a D8 in grass gis with the command r.watershed.

3rd: Digital elevation map of an area in Souh Africa close to Marakele National park. RasterLayer, SRTM 1 Arc'', bilinear interpolated to +proj=utm +zone=35 +datum=WGS84 +units=m +no_defs +ellps=WGS84 and a resolution of 30 m. 

}
\source{
http://earthexplorer.usgs.gov/
}
\references{
%%  ~~ possibly secondary sources and usages ~~
}
\examples{
data("work.data",package="lineaDEM") #import data
plot(work.data[[1]])
}
\keyword{datasets}
